<template lang="pug">
div
  .row
    q-banner.q-mb-lg.bg-orange.full-width.text-white(rounded)
      .row.items-center
        .col-12.col-md-6.text-body1 CAREFUL! Switching the phase will prevent any reports in other phases for EVERYONE.
        .col-12.col-md-6.text-right
          q-btn-toggle.text-uppercase(
            v-model="config.current_phase",
            toggle-color="secondary",
            :options="phaseoptions",
            flat
            @input="savePhase"
          )

  .text-center(v-if="judgingStart()")
    q-btn.q-px-md.q-my-md(
      rounded,
      color="secondary",
      @click="startJudgingProgress",
      :label="$t('start_judging')"
    )

  q-card(flat bordered).q-mb-md
    q-card-section
      .text-h6 Reporter Email List
    q-separator
    q-card-section
      q-btn(outline color="primary" @click="getUsers" :loading="downloadUsers") Download CSV

  q-card(flat bordered).q-mb-md
    q-card-section
      .text-h6 Manual Edit (top+tail)
      .text-overline Note: Videos MUST have audio, and they should be full HD (1920x1080) in order to get the watermark applied correctly. Videos take approx. 3 mins to edit, before which the download link below will not work.
      .text-overline If a video fails to edit, the link will be invalid.

    q-separator
    q-card-section
      q-card-section
        q-file(
        ref="formInput",
        v-model="inputVal",
        label="File to Edit"
        outlined,
        accept=".mp4, video/*",
        :disable="uploading"
        lazy-rules,
        :rules="[(val) => !!val || $t('video_required')]"
      )
        q-btn(@click="upload" color="primary"  :loading="uploading" :percentage="progress" :disable="uploading") Upload
    q-separator
    q-scroll-area(style="height:600px;")
      q-list(separator)
        q-item(v-for="file of files" :key="file.name")
          q-item-section {{file.name}}
          q-item-section(side)
            q-btn(flat dense round icon="download" type="a" :href="`https://d3gj81j4mgprz9.cloudfront.net/dropbox/${file.name}/hd_video.mp4`")

  q-card.q-mb-lg(v-if="config.opensAt" flat bordered)
    q-card-section
      .text-h6 Master Settings
    q-separator
    q-card-section
      q-toggle(v-model="config.youtube" label="Publish to YouTube")
      q-toggle(v-model="config.privacy" false-value="unlisted" :disabled="!config.youtube"
      true-value="public" label="Publish Public")

      .text-overline Opens
      .row
        .col-auto
          q-time(:value="getTime(config.opensAt)" @input="updateTimeC($event,'opensAt')")
        .col-auto
          q-date(:value="getDate(config.opensAt)" @input="updateDateC($event,'opensAt')")
      .text-overline Closes
      .row
        .col-auto
          q-time(:value="getTime(config.closesAt)" @input="updateTimeC($event,'closesAt')")
        .col-auto
          q-date(:value="getDate(config.closesAt)" @input="updateDateC($event,'closesAt')")

  q-card(v-for="(phase,key) of config.phases" :key="key" flat bordered).q-mb-lg
    q-card-section
      .text-h6 {{phase.code}}
    q-separator
    q-card-section
      q-toggle(v-model="phase.visible" label="Visible")
      .text-overline Opens
      .row
        .col-auto
          q-time(:value="getTime(phase.opensAt)" @input="updateTime($event,key,'opensAt')")
        .col-auto
          q-date(:value="getDate(phase.opensAt)" @input="updateDate($event,key,'opensAt')")
      .text-overline Closes
      .row
        .col-auto
          q-time(:value="getTime(phase.closesAt)" @input="updateTime($event,key,'closesAt')")
        .col-auto
          q-date(:value="getDate(phase.closesAt)" @input="updateDate($event,key,'closesAt')")
  
</template>

<script>
import { db, adminListUsers, storage } from "@/db";
// import firebase from "firebase/app";
import "firebase/storage";
import { DateTime } from "luxon";

import { mapState, mapActions } from "vuex";
import { map, filter, includes } from "lodash";
import { exportFile } from "quasar";

// const uuid = require("uuid");

export default {
  components: {},
  computed: {
    phaseoptions() {
      if (!this.config.phases) return [];
      return map(filter(this.config.phases, "visible"), (m) => {
        return {
          value: m.code,
          label: this.$t("phase.phase_" + m.code),
        };
      });
    },
    ...mapState({
      user: (state) => state.user,
      judging: (state) => state.judging,
    }),
  },
  data: () => {
    return {
      config: {
        current_phase: -1,
      },
      inputVal: null,
      loading: false,
      uploading: false,
      progress: 0,
      files: [],
      downloadUsers: false,
    };
  },
  watch: {
    config: {
      deep: true,
      // immediate:true,
      async handler() {
        console.log(this.config);

        await db
          .collection("config")
          .doc("meta")
          .update(this.config);
      },
    },
  },
  mounted() {
    this.listFiles();
  },
  methods: {
    async getUsers() {
      this.downloadUsers = true;
      let users = (await adminListUsers()).data;
      this.downloadUsers = false;
      // console.log(users);
      exportFile("reporters.csv", users);
    },
    listFiles() {
      storage
        .ref()
        .child(`dropbox/`)
        .listAll()
        .then((res) => {
          // res.prefixes.forEach((folderRef) => {
          //   // All the prefixes under listRef.
          //   // You may call listAll() recursively on them.
          // });
          res.items.forEach((itemRef) => {
            // All the items under listRef.
            this.files.push(itemRef);
          });
        })
        .catch((error) => {
          // Uh-oh, an error occurred!
          console.error(error);
        });
    },
    async upload() {
      const filename = `${this.inputVal.name}_${DateTime.now().toHTTP()}`;
      const storageRef = storage.ref();

      // [START storage_monitor_upload]
      var uploadTask = storageRef
        .child(`dropbox/${filename}.mp4`)
        .put(this.inputVal);

      this.uploading = true;
      // Register three observers:
      // 1. 'state_changed' observer, called any time the state changes
      // 2. Error observer, called on failure
      // 3. Completion observer, called on successful completion
      uploadTask.on(
        "state_changed",
        (snapshot) => {
          // Observe state change events such as progress, pause, and resume
          // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
          var progress =
            (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
          // console.log("Upload is " + progress + "% done");
          this.progress = progress;
          // switch (snapshot.state) {
          //   case firebase.storage.TaskState.PAUSED: // or 'paused'
          //     console.log("Upload is paused");
          //     break;
          //   case firebase.storage.TaskState.RUNNING: // or 'running'
          //     console.log("Upload is running");
          //     break;
          // }
        },
        (error) => {
          // Handle unsuccessful uploads
          console.error(error);
        },
        () => {
          this.uploading = false;
          // Handle successful uploads on complete
          // For instance, get the download URL: https://firebasestorage.googleapis.com/...
          // uploadTask.snapshot.ref.getDownloadURL().then((downloadURL) => {
          //   console.log("File available at", downloadURL);
          // });
        }
      );
    },
    getTime(t) {
      return DateTime.fromSeconds(t._seconds).toFormat("hh:mm:ss");
    },
    getDate(t) {
      return DateTime.fromSeconds(t._seconds).toFormat("yyyy/MM/dd");
    },
    updateTimeC(event, field) {
      let old = DateTime.fromSeconds(this.confi[field]._seconds);

      // console.log(old);
      let newc = old.set({
        hour: event.split(":")[0],
        minute: event.split(":")[1],
      });

      // console.log(newc);
      this.config[field]._seconds = newc.toSeconds();

      // console.log(field);
    },
    updateDateC(event, field) {
      let old = DateTime.fromSeconds(this.config[field]._seconds);
      // console.log(event);

      // console.log(old);
      let newc = old.set({
        year: event.split("/")[0],
        month: event.split("/")[1],
        day: event.split("/")[2],
      });

      // console.log(newc);
      this.config[field]._seconds = newc.toSeconds();

      // console.log(field);
    },
    updateTime(event, index, field) {
      let old = DateTime.fromSeconds(this.config.phases[index][field]._seconds);

      // console.log(old);
      let newc = old.set({
        hour: event.split(":")[0],
        minute: event.split(":")[1],
      });

      // console.log(newc);
      this.config.phases[index][field]._seconds = newc.toSeconds();

      // console.log(field);
    },
    updateDate(event, index, field) {
      let old = DateTime.fromSeconds(this.config.phases[index][field]._seconds);
      // console.log(event);

      // console.log(old);
      let newc = old.set({
        year: event.split("/")[0],
        month: event.split("/")[1],
        day: event.split("/")[2],
      });

      // console.log(newc);
      this.config.phases[index][field]._seconds = newc.toSeconds();

      // console.log(field);
    },
    ...mapActions(["startJudging"]),
    async startJudgingProgress() {
      this.$q.loading.show({
        message: this.$t("waiting_judging"),
      });
      const error = await this.startJudging();
      this.$q.loading.hide();
      if (!error) {
        this.judgeStarted = true;
        this.$q.notify({
          type: "positive",
          message: this.$t("judging_success"),
        });
      } else
        this.$q.notify({
          type: "negative",
          message: this.$t("judging_error"),
        });
    },
    async savePhase() {
      try {
        await db
          .collection("config")
          .doc("meta")
          .update({
            current_phase: this.config.current_phase,
          });
      } catch (e) {
        this.showError(e);
      }
    },

    getChipColor(status) {
      if (status === "submitted") {
        return "warning";
      } else if (status === "readyformoderation") {
        return "grey";
      } else if (status === "moderated") {
        return "info";
      } else if (status === "rejected" || status == "error") {
        return "negative";
      } else if (
        status === "translated" ||
        status === "subtitled" ||
        status == "draft"
      ) {
        return "warning";
      } else if (status === "finalised" || status == "edited") {
        return "positive";
      } else {
        return "info";
      }
    },
    judgingStart() {
      if (!this.user) return false;
      return (
        includes(this.user.roles, "superadmin") &&
        this.judging &&
        !this.judgeStarted
      );
    },
  },
  firestore: {
    config: db.collection("config").doc("meta"),
  },
};
</script>

<style lang="sass"></style>
